/*
 * Create table with source passwords hashes ...
 * You may use [syslogin/sysXlogins] table from another server...
 * Just load it into your server.
 */

if not exists (select * from sysobjects where id = object_id('dbo.passwords') and type = 'U')
	EXEC ( 'CREATE TABLE dbo.passwords (name varchar(30),password varchar(30),xstatus int NULL, srvid int NULL)' )
GO

/*
 * Fill passwords table...
 */

declare @sql_ver int, @tbl_syslogins varchar(255), @s varchar(255)
select @sql_ver	= CASE
			WHEN patindex('%Microsoft%SQL%Server%6.50%',@@version) > 0	THEN 6
			WHEN patindex('%Microsoft%SQL%Server%7.00%',@@version) > 0	THEN 7
			ELSE 0
		  END
select @tbl_syslogins = 'master..' + CASE @sql_ver WHEN 6 THEN 'syslogins' ELSE 'sysxlogins' END

if ( @sql_ver = 6)
	select @s = 'insert into passwords(name, password) select name, password from ' +
                    @tbl_syslogins + ' where password IS NOT NULL'
else
	select @s = 'insert into passwords(name, password, xstatus, srvid) select name, password, xstatus, srvid from ' +
                    @tbl_syslogins + ' where srvid IS NULL and  password IS NOT NULL'

exec ( @s )


/*
 * Create result table (for plaintext passwords)
 */
if not exists (select * from sysobjects where id = object_id('dbo.results') and type = 'U')
	EXEC ( 'CREATE TABLE dbo.results (name varchar(50), password varchar(50))' )
GO


/*
 * Delete rows from table 'passwords' for known passwords (speed-up main loop)
 * Advise: delete unnecessary rows from 'passwords' table every time when it possibly
 * Note: NEVER DELETE ANY ROWS DIRECTLY FROM syslogins/sysXlogins table !!!
 * 
 */

delete from passwords where exists(select * from results where name = passwords.name)


/*
 * Create wordlist table for dictionary attack...
 */
if not exists (select * from sysobjects where id = object_id('dbo.WordList') and type = 'U')
	EXEC ( 'CREATE TABLE dbo.WordList (word varchar(50))' )
GO

/*
 * Filling wordlist's table...
 * Advise: Use [bcp] utility.
 * Command line example: bcp Your_db_name..WordList in DataFileName -c -S YourSQLServerName -U username -P password
 */

---------------------------------------------------------------------------------
/*
 * Perform dictionary attack...
 */

exec sp_get_passwords
	 @pwd_table	= 'passwords'
	,@rslt_table	= 'results'
	,@start		= '-'
	,@stop		= '-'
	,@dictionary	= 'WordList'
	,@col_name	= 'word'
GO

delete from passwords where exists(select * from results where name = passwords.name)
GO


/*
 * Create "SaveStatusTable"
 */
if not exists (select * from sysobjects where id = object_id('dbo.SavCombinations') and type = 'U')
	EXEC ( 'CREATE TABLE dbo.SavCombinations (Combination varchar(50))' )
GO


/*
 * Perform  brute force attack...
 * If you canceled the long time procedure execution and wanna continue it -
 * comment parameter @start. (In this case last saved combination will be taken from "SaveTable")
 */
exec sp_get_passwords
         @alphabet	= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'
	,@pwd_table	= 'passwords'
	,@save_table	= 'SavCombinations'
	,@save_col_name	= 'Combination'
	,@rslt_table	= 'results'
	,@start		= 'A'		-- Comment this line if you already started this 'sp' with '@save_table' parameter and want to continue from previous combination.
	,@stop		= '99999999'
	,@max_len	= 8		-- Optional parameter
	,@delta		= 10000		-- Show progress info after every 10000 combinations

GO

delete from passwords where exists(select * from results where name = passwords.name)
GO

/* Advise: if you have access to several SQL servers you may split up
 * brute force attack on to several parts...
 * For example:
 --Run on the 1st server...
     exec sp_get_passwords
         @alphabet	= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'
	,@pwd_table	= 'passwords'
	,@save_table	= 'SavCombinations'
	,@save_col_name	= 'Combination'
	,@rslt_table	= 'results'
	,@start		= 'A'
	,@stop		= 'Q9999999'
	,@max_len	= 8
	,@delta		= 10000

     GO

 --Run on the 2nd server...
     exec sp_get_passwords
         @alphabet	= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'
	,@pwd_table	= 'passwords'
	,@save_table	= 'SavCombinations'
	,@save_col_name	= 'Combination'
	,@rslt_table	= 'results'
	,@start		= 'Q9999999'
	,@stop		= '99999999'
	,@max_len	= 8
	,@delta		= 10000

     GO
 */